'==========================================================================
'
' VBScript Source File -- Created with SAPIEN Technologies PrimalScript 3.1
'
' NAME: MoveUsertoOU.vbs
'
Option Explicit 
'On Error Resume Next 

Dim strUserDN,  objUser, objOU, strNTName, strOUDN
Dim objRootDSE, strDNSDomain, objTrans, strNetBIOSDomain
Dim objFSO, strFilePath, objFile

Const ADS_NAME_INITTYPE_DOMAIN = 1
Const ADS_NAME_TYPE_NT4 = 3
Const ADS_NAME_TYPE_1179 = 1

'Creating the file system object
Set objFSO = CreateObject("Scripting.FileSystemObject")

' Determine DNS domain name from RootDSE object.
Set objRootDSE = GetObject("LDAP://RootDSE")
strDNSDomain = objRootDSE.Get("defaultNamingContext")

'Specify the text file of user names.
strFilePath = InputBox("What is the name of the file?" & VbCrLf & VbCrLf & "Note: If the file is not in the same directory" & VbCrLf & "as the script then it must be the full path of the file.","File name","userslist.txt")
If strFilePath = vbCancel Then
	MsgBox "You have choosen to quit the script."
	WScript.quit
End If

'Check to see if file exists
If Not objFSO.FileExists(strFilePath) Then
	MsgBox "The file " & strFilePath & " does not exist please check and rerun.  The script will quit now.", vbCritical, "Error"
	WScript.Quit
End If


' Specify the Organization Unit where users are to be moved.
strOUDN = InputBox ("What Organization Unit do you want to move the users accounts to?","Organization Unit", "OU=New Location,OU=Users," & strDNSDomain)
If strOUDN = vbCancel Then
	MsgBox "You have choosen to quit the script."
	WScript.quit
End If

'binding to OU
Err.Clear
Set objOU = GetObject("LDAP://" & strOUDN)
If Not Err.Number = 0 Then
	MsgBox "Unable to bind to OU.  Please check OU path spelling.  The script will now quit."
	WScript.Quit
End If 


' Open the file for read access.
Set objFile = objFSO.OpenTextFile(strFilePath, 1)


' Use the NameTranslate object to find the NetBIOS
' domain name from the DNS domain name.
Set objTrans = CreateObject("NameTranslate")
objTrans.Init ADS_NAME_TYPE_NT4, strDNSDomain
objTrans.Set ADS_NAME_TYPE_1179, strDNSDomain
strNetBIOSDomain = objTrans.Get(ADS_NAME_TYPE_NT4)
' Remove trailing backslash.
strNetBIOSDomain = Left(strNetBIOSDomain, _
  Len(strNetBIOSDomain) - 1)



' Use the NameTranslate object to convert the NT user names
' to the Distinguished Name required for the LDAP provider.
objTrans.Init ADS_NAME_INITTYPE_DOMAIN, strNetBIOSDomain



' Read each line of the file, convert each NT name to the
' Distinguished Name, bind to the user object, And move
' to the designated OU.
Do Until objFile.AtEndOfStream
  ' Read NT name of user (sAMAccountName) from text file.
  strNTName = Trim(objFile.ReadLine)
  If strNTName <> "" Then
    On Error Resume Next
    objTrans.Set ADS_NAME_TYPE_NT4, strNetBIOSDomain & "\" & strNTName
    If Err.Number <> 0 Then
      On Error GoTo 0
     Wscript.Echo "User " & strNTName _
       & " not found in Active Directory"
    Else
      On Error GoTo 0
      ' Retrieve Distinguished Name of user.
      strUserDN = objTrans.Get(ADS_NAME_TYPE_1179)
      ' Bind to user object, to compare Parent container to target OU.
      Set objUser = GetObject("LDAP://" & strUserDN)
      If UCase(objUser.Parent) = UCase("LDAP://" & strOUDN) Then
      	Wscript.Echo "User " & strNTName & " already in OU"
       	Wscript.Echo "  DN: " & strUserDN
      Else
   		 On Error Resume Next
         objOU.MoveHere "LDAP://" & strUserDN, vbNullString
      End If
    End If
  End If
Loop

